class Cuboctahedron extends Polys {
/*

CUBOCTAHEDRON    (volume = 20)
=============

Vertices             Edges

O = I+J = 2 1 1 0    (O,P)(P,R)(R,Q)(Q,O)
P = I+K = 2 1 0 1    (O,W)(W,S)(S,Z)(Z,O)
Q = I+L = 1 2 1 0    (Q,W)(W,U)(U,X)(X,Q)
R = I+M = 1 2 0 1    (P,Z)(Z,T)(T,Y)(Y,P)
S = N+J = 1 0 2 1    (R,X)(X,V)(V,Y)(Y,R)
T = N+K = 1 0 1 2    (T,S)(S,U)(U,V)(V,T)
U = N+L = 0 1 2 1
V = N+M = 0 1 1 2
W = J+L = 1 1 2 0
X = L+M = 0 2 1 1
Y = M+K = 1 1 0 2
Z = K+J = 1 0 1 2


	Last change:  KU   18 Mar 1999   10:09 pm
*/
     Cuboctahedron(){

       nbedges = 24;
       volume = 20;
       edgecolor = "Yellow";
       edgediam = (float)0.04;
       edges = new Edge[nbedges];

       edges[ 0] = new Edge(O,P);
       edges[ 1] = new Edge(P,R);
       edges[ 2] = new Edge(R,Q);
       edges[ 3] = new Edge(Q,O);

       edges[ 4] = new Edge(O,W);
       edges[ 5] = new Edge(W,S);
       edges[ 6] = new Edge(S,Z);
       edges[ 7] = new Edge(Z,O);

       edges[ 8] = new Edge(Q,W);
       edges[ 9] = new Edge(W,U);
       edges[10] = new Edge(U,X);
       edges[11] = new Edge(X,Q);

       edges[12] = new Edge(P,Z);
       edges[13] = new Edge(Z,T);
       edges[14] = new Edge(T,Y);
       edges[15] = new Edge(Y,P);

       edges[16] = new Edge(R,X);
       edges[17] = new Edge(X,V);
       edges[18] = new Edge(V,Y);
       edges[19] = new Edge(Y,R);

       edges[20] = new Edge(T,S);
       edges[21] = new Edge(S,U);
       edges[22] = new Edge(U,V);
       edges[23] = new Edge(V,T);

    }
}
