class Vertex {

   static final double ROOT2 = Math.sqrt(2);
   public double[] tuple;
   public double[] xyz;

   Vertex(double[] coords){
      tuple = new double[4];
      for (int i=0;i<4;i++) tuple[i] = coords[i];
   }

   public Vertex inv(){
      return simplify(new Vertex(new double[]
                             {-tuple[0],
                              -tuple[1],
                              -tuple[2],
                              -tuple[3]}
                      )
                 );
   }

   public Vertex add(Vertex v){
      return simplify(new Vertex(new double[]
                             {tuple[0]+v.tuple[0],
                              tuple[1]+v.tuple[1],
                              tuple[2]+v.tuple[2],
                              tuple[3]+v.tuple[3]}
                      )
                  );
   }

   private Vertex simplify(Vertex v){
      double minval = v.tuple[0];
      for (int i=1;i<4;i++) minval = minval<v.tuple[i]?minval:v.tuple[i];
      for (int i=0;i<4;i++) v.tuple[i] -= minval;
      return v;
   }

   private void quad2xyz(){
	xyz = new double[3];
        xyz[0] = 1/ROOT2 * (tuple[0] - tuple[1] - tuple[2] + tuple[3]);
        xyz[1] = 1/ROOT2 * (tuple[0] - tuple[1] + tuple[2] - tuple[3]);
        xyz[2] = 1/ROOT2 * (tuple[0] + tuple[1] - tuple[2] - tuple[3]);
   }

   public String output(){
        return "<"+tuple[0]+", "
                  +tuple[1]+", "
                  +tuple[2]+", "
                  +tuple[3]+">";
   }

   public String xyzout(){
	quad2xyz();
        return "<"+xyz[0]+", "
                  +xyz[1]+", "
                  +xyz[2]+">";
   }

}
